searchNodes=[{"doc":"pool_lad is the younger &amp; more energetic version of :poolboy.It's still the lightweight, generic pooling library with focus on simplicity, performance, and rock-solid disaster recovery that we all love......but it has just gotten a much needed facelift!Sample usageThe APIs are almost identical to those of :poolboy.Via manual ownership:iex(1)&gt; {:ok, worker} = PoolLad.borrow(MyWorkerPool) {:ok, #PID&lt;0.256.0&gt;} iex(2)&gt; GenServer.call(worker, :get_random_colour) :blue iex(3)&gt; PoolLad.return(MyWorkerPool, worker) :okVia transactional ownership:iex(1)&gt; PoolLad.transaction( ...(1)&gt; MyWorkerPool, ...(1)&gt; fn worker -&gt; GenServer.call(worker, :get_random_colour) end ...(1)&gt; ) :green","ref":"PoolLad.html","title":"PoolLad","type":"module"},{"doc":"Attempts to &quot;borrow&quot; a worker (pid), or waits until one becomes available.ExamplesGet, or waitIf no workers are currently available waits (blocks) until one becomes available, or until timeout elapses in which case {:error, :timeout} will be returned.Assuming we only have one worker available:iex(1)&gt; {:ok, pid} = PoolLad.borrow(MyWorkerPool) {:ok, #PID&lt;0.229.0&gt;} iex(2)&gt; result = PoolLad.borrow(MyWorkerPool) # will wait (block) for 5 seconds first {:error, :timeout}Synchronous getIf no workers are currently available, returns {:error, :full} immediately.Assuming we only have one worker available:iex(1)&gt; {:ok, pid} = PoolLad.borrow(MyWorkerPool, false) {:ok, #PID&lt;0.229.0&gt;} iex(2)&gt; result = PoolLad.borrow(MyWorkerPool, false) # will return imediately {:error, :full}Custom timeoutYou can configure your own timeout like so:iex(1)&gt; {:ok, pid} = PoolLad.borrow(MyWorkerPool, true, 2_500)","ref":"PoolLad.html#borrow/3","title":"PoolLad.borrow/3","type":"function"},{"doc":"Returns a specification to start this module under a Supervisor.Usagepool_opts = [name: MyWorkerPool, worker_count: 3, worker_module: MyWorker] worker_opts = [initial_colours: ~w(red green blue)a] children = [ {PoolLad, {pool_opts, worker_opts}} ] Supervisor.start_link(children, strategy: :one_for_one)Calls child_spec/2.","ref":"PoolLad.html#child_spec/1","title":"PoolLad.child_spec/1","type":"function"},{"doc":"Returns a specification to start this module under a Supervisor.Usagepool_opts = [name: MyWorkerPool, worker_count: 3, worker_module: MyWorker] worker_opts = [initial_colours: ~w(red green blue)a] children = [ PoolLad.child_spec(pool_opts, worker_opts) ] Supervisor.start_link(children, strategy: :one_for_one)","ref":"PoolLad.html#child_spec/2","title":"PoolLad.child_spec/2","type":"function"},{"doc":"Returns the borrowed worker (pid) back to the pool.Examplesiex(1)&gt; {:ok, pid} = PoolLad.borrow(MyWorkerPool) {:ok, #PID&lt;0.229.0&gt;} iex(2)&gt; PoolLad.return(MyWorkerPool, pid) :ok⚠️ If the worker died while on loan and a return was attempted, the return will be accepted but ignored and a warning will be logged.⚠️ If the return was attempted more than once, the return will be accepted but ignored and a warning will be logged.","ref":"PoolLad.html#return/2","title":"PoolLad.return/2","type":"function"},{"doc":"Starts a new PoolLad worker pool.Needs to be supplied pool_opts and worker_opts.Pool options;:name (required): unique name, used to interact with the pool:worker_count (required): the number of workers to be started and supervised:worker_module (required): the module to be used as a worker, must implement child_spec/1Worker options; passed as the init_arg when starting worker_module.SupervisionSee child_spec/1, child_spec/2.","ref":"PoolLad.html#start_link/2","title":"PoolLad.start_link/2","type":"function"},{"doc":"Both the borrow and the return are facilitated via a single transaction.Should function raise, a safe return of the worker to the pool is guaranteed.iex(1)&gt; PoolLad.transaction( ...(1)&gt; MyWorkerPool, ...(1)&gt; fn worker -&gt; GenServer.call(worker, :get_random_colour) end ...(1)&gt; ) :green","ref":"PoolLad.html#transaction/3","title":"PoolLad.transaction/3","type":"function"},{"doc":"MIT LicenseCopyright (c) 2020 Slavomir VojacekPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Overviewpool_lad is the younger &amp; more energetic version of poolboy.It's still the lightweight, generic pooling library with focus on simplicity, performance, and rock-solid disaster recovery that we all love......but it has just gotten a much needed facelift!","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Add :pool_lad as a dependency to your project's mix.exs:defp deps do [ {:pool_lad, &quot;~&gt; 0.0.4&quot;} ] end","ref":"overview.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"See PoolLad.","ref":"overview.html#api-documentation","title":"Overview - API Documentation","type":"extras"},{"doc":"The APIs are almost identical to those of :poolboy.Via manual ownership:iex(1)&gt; {:ok, pid} = PoolLad.borrow(MyWorkerPool) {:ok, #PID&lt;0.229.0&gt;} iex(2)&gt; GenServer.call(pid, :get_latest_count) {:ok, 42} iex(3)&gt; PoolLad.return(MyWorkerPool, pid) :okVia transactional ownership:iex(1)&gt; PoolLad.transaction( MyWorkerPool, fn pid -&gt; GenServer.call(pid, :get_latest_count) end ) {:ok, 42}","ref":"overview.html#sample-usage","title":"Overview - Sample usage","type":"extras"},{"doc":"Define a worker serverdefmodule MyWorker do @moduledoc false use GenServer @this_module __MODULE__ def start_link(opts), do: GenServer.start_link(@this_module, opts) @impl true def init(opts) do initial_colours = Keyword.get(opts, :initial_colours, []) {:ok, initial_colours} end @impl true def handle_call(:get_random_colour, _from, colours) do colour = Enum.random(colours) {:reply, colour, colours} end endStart the poolpool_opts = [ name: MyWorkerPool, worker_count: 3, worker_module: MyWorker ] worker_opts = [initial_colours: ~w(red green blue)a] children = [ PoolLad.child_spec(pool_opts, worker_opts) ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts)Do the workVia manual ownership:iex(1)&gt; {:ok, worker} = PoolLad.borrow(MyWorkerPool) {:ok, #PID&lt;0.256.0&gt;} iex(2)&gt; GenServer.call(worker, :get_random_colour) :blue iex(3)&gt; PoolLad.return(MyWorkerPool, worker) :okVia transactional ownership:iex(1)&gt; PoolLad.transaction( ...(1)&gt; MyWorkerPool, ...(1)&gt; fn worker -&gt; GenServer.call(worker, :get_random_colour) end ...(1)&gt; ) :green","ref":"overview.html#example-application","title":"Overview - Example application","type":"extras"},{"doc":"Elixir-firstModern APIs, e.g. DynamicSupervisorLess code, less pesky logs, less noiseMore documentationSame performanceMaintained0 dependencies","ref":"overview.html#pool_lad-over-poolboy","title":"Overview - pool_lad over poolboy","type":"extras"}]